//+------------------------------------------------------------------+
//|                                           #MTF Reversal_v1_3.mq4 |
//|                                                       ServerUang |
//|                                        http://www.forex-tsd.com/ |
//+------------------------------------------------------------------+
#property copyright "ServerUang"
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
extern string Indicator_Name = "#MTF Reversal_v1_3";
extern int Side  =  3;
extern int Rev_Y = 10; 
extern int Rev_X =  0;
extern color UpColor = Blue; 
extern color DnColor = Red;  
extern color TextColor  = Black;

extern int CCI_period = 20;
extern int CCI_apply  =  0;
extern double CCI_OverBought = 200;
extern double CCI_OverSold = -200;

extern int RSI_period = 5;
extern int RSI_apply  =  0;
extern double RSI_OverBought = 80;
extern double RSI_OverSold = 20;

extern int WPR_period = 20;
extern double  WPR_OverBought = -11;
extern double WPR_OverSold = -89;

extern int Stoch_Kperiod = 20;
extern int Stoch_Dperiod = 3;
extern int Stoch_slowing = 3;
extern int Stoch_OverBought = 80;
extern int Stoch_OverSold = 20;

// Bollinger Bands Parameters
extern string Bands_Parameters = "Bollinger Bands Parameters" ; // change
extern int Bands_Periode = 20;
extern int Bands_Deviation = 2;
extern int Bands_shift = 0;
extern int Bands_Applied_price = PRICE_CLOSE;

// Bollinger Bands variables
double Spread, Range, bbP, bbM;

// ==================================================================+
string text, font, UpSymbol="",  DnSymbol="", Simbol; // symbol=241 and 242
color  SymbolColor;
double TF, value, coulom;
int    size, space, x, y, n;

// ==================================================================+
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 3) != "Rev")
           continue;
       ObjectDelete(label);   
     }   //----
   return(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   font="Arial Bold"; size=10;
   Write("Rev12", Side, Rev_X+22, Rev_Y+90, "MTF REVERSAL", size, font, TextColor);
   font="Tahoma Narrow"; size=7; 
   if (MathMod(Side,2)>0) {text="M1   M5  M15  M30  H1     H4  D1";}
             else {text="D1 H4     H1   M30  M15  M5  M1";}
   x=8+Rev_X;  y=10+Rev_Y; 
   Write("Rev01", Side, x, y, text, size, font, TextColor);
   x=x+132; y=y+10; space=15;
   Write("Rev02", Side, x, y+(0*space), "CCI", size, font, TextColor);
   Write("Rev03", Side, x, y+(1*space), "RSI", size, font, TextColor);
   Write("Rev04", Side, x, y+(2*space), "WPR", size, font, TextColor);
   Write("Rev05", Side, x, y+(3*space), "Sto", size, font, TextColor);
   Write("Rev06", Side, x, y+(4*space), "BB" , size, font, TextColor);
   
   // Signals
   Spread=(Ask - Bid)/Point;
   n=1; coulom=20; space=14;
   while (n<=7)
      {
       switch (n)
          {
           case 1: TF=   1; Range=Spread; break;
           case 2: TF=   5; Range=Spread*2; break;
           case 3: TF=  15; Range=Spread*2; break;
           case 4: TF=  30; Range=Spread*2; break;
           case 5: TF=  60; Range=Spread*2; break;
           case 6: TF= 240; Range=Spread*2; break;
           case 7: TF=1440; Range=Spread*2; break;
          }
    
       text=DoubleToStr(n,0);
       font="Arial Bold"; size=30;
       // CCI Reversal
       value=iCCI(Symbol(), TF, CCI_period, CCI_apply, 0);
       if (value>CCI_OverBought)
            { Simbol=DnSymbol; SymbolColor=DnColor; 
              Write("Rev07"+text, Side, x-(n*coulom), y+(0*space), Simbol, 9, "Wingdings", SymbolColor);   
            }
       else if (value<CCI_OverSold)
            { Simbol=UpSymbol; SymbolColor=UpColor; 
              Write("Rev07"+text, Side, x-(n*coulom), y+(0*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else ObjectDelete("Rev07"+text);
       
      
       // RSI Reversal
       value=iRSI(Symbol(), TF, RSI_period, RSI_apply, 0);
       if (value>RSI_OverBought) 
            { Simbol=DnSymbol; SymbolColor=DnColor; 
              Write("Rev08"+text, Side, x-(n*coulom), y+(1*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else if (value<RSI_OverSold)
            { Simbol=UpSymbol; SymbolColor=UpColor; 
              Write("Rev08"+text, Side, x-(n*coulom), y+(1*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else ObjectDelete("Rev08"+text);
       
       
       // WPR Reversal
       value=iWPR(Symbol(), TF, WPR_period, 0);
       if (value>WPR_OverBought) 
            { Simbol=DnSymbol; SymbolColor=DnColor; 
              Write("Rev09"+text, Side, x-(n*coulom), y+(2*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else if (value<WPR_OverSold)
            { Simbol=UpSymbol; SymbolColor=UpColor; 
              Write("Rev09"+text, Side, x-(n*coulom), y+(2*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else ObjectDelete("Rev09"+text);
       
       
       // Stochastic Reversal
       value=iStochastic(Symbol(), TF, Stoch_Kperiod, Stoch_Dperiod, Stoch_slowing, MODE_SMA, 0, MODE_SIGNAL, 0);
       if (value>Stoch_OverBought) 
            { Simbol=DnSymbol; SymbolColor=DnColor; 
              Write("Rev10"+text, Side, x-(n*coulom), y+(3*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else if (value<Stoch_OverSold)
            { Simbol=UpSymbol; SymbolColor=UpColor; 
              Write("Rev10"+text, Side, x-(n*coulom), y+(3*space), Simbol, 9, "Wingdings", SymbolColor);
            }
       else ObjectDelete("Rev10"+text);
       
       
       // BollingerBands Reversal
       
       bbP   = iBands(Symbol(),TF, Bands_Periode, Bands_Deviation, Bands_shift, Bands_Applied_price,MODE_PLUSDI,0);
       bbM   = iBands(Symbol(),TF, Bands_Periode, Bands_Deviation, Bands_shift, Bands_Applied_price,MODE_MINUSDI,0);
       if (Bid > (bbP+Range) )
          { Simbol=DnSymbol; SymbolColor=DnColor;
            Write("Rev11"+text, Side, x-(n*coulom), y+(3*space), Simbol, 9, "Wingdings", SymbolColor);
          }
       else if (Bid < (bbM-Range) )
          { Simbol=UpSymbol; SymbolColor=UpColor; 
            Write("Rev11"+text, Side, x-(n*coulom), y+(3*space), Simbol, 9, "Wingdings", SymbolColor);
          }
       else ObjectDelete("Rev11"+text);
       
       n++;
       
      } // end while 
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
// Write Procedure
void Write(string LBL, double side, int pos_x, int pos_y, string text, int fontsize, string fontname, color Tcolor=CLR_NONE)
     {
       //Label_Teks = LBL;
       ObjectCreate(LBL, OBJ_LABEL, 0, 0, 0);
       ObjectSetText(LBL,text, fontsize, fontname, Tcolor);
       ObjectSet(LBL, OBJPROP_CORNER, side);
       ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
       ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
     }
     
//+------------------------------------------------------------------+